Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/GPTraining.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/GPTraining.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/GPTraining.java	(revision 135)
@@ -1,2 +1,3 @@
+
 package de.ugoe.cs.cpdp.training;
 
@@ -45,84 +46,148 @@
  * Genetic Programming Trainer
  * 
- * Implementation (mostly) according to Liu et al. Evolutionary Optimization of Software Quality Modeling with Multiple Repositories.
+ * Implementation (mostly) according to Liu et al. Evolutionary Optimization of Software Quality
+ * Modeling with Multiple Repositories.
  * 
- * - GPRun is a Run of a complete Genetic Programm Evolution, we want several complete runs.
- * - GPVClassifier is the Validation Classifier
- * - GPVVClassifier is the Validation-Voting Classifier
+ * - GPRun is a Run of a complete Genetic Programm Evolution, we want several complete runs. -
+ * GPVClassifier is the Validation Classifier - GPVVClassifier is the Validation-Voting Classifier
  * 
- *  config: <setwisetrainer name="GPTraining" param="populationSize:1000,numberRuns:10" />
+ * config: <setwisetrainer name="GPTraining" param="populationSize:1000,numberRuns:10" />
+ * 
+ * @author Alexander Trautsch
  */
-public class GPTraining implements ISetWiseTrainingStrategy, IWekaCompatibleTrainer  {
-    
+public class GPTraining implements ISetWiseTrainingStrategy, IWekaCompatibleTrainer {
+
+    /**
+     * the interal validation-and-voting classifier
+     */
     private GPVVClassifier classifier = null;
-    
-    // default values from the paper
+
+    /**
+     * size of the population of the genetic program; default from the paper is 1000
+     */
     private int populationSize = 1000;
+
+    /**
+     * minimal depth of the S-expression tree at the start of the training; default from the paper
+     * is 2
+     */
     private int initMinDepth = 2;
+
+    /**
+     * maximal depth of the S-expression tree at the start of the training; default from the paper
+     * is 6
+     */
     private int initMaxDepth = 6;
+
+    /**
+     * size of the tournaments used for selection; default from the paper is 7
+     */
     private int tournamentSize = 7;
+
+    /**
+     * number of genetic generations considered (i.e., number of iterations; default from the paper
+     * is 50
+     */
     private int maxGenerations = 50;
+
+    /**
+     * weight factor for the prediction errors for cost estimation; default from the paper is 15
+     */
     private double errorType2Weight = 15;
-    private int numberRuns = 20;  // im paper 20 per errorType2Weight then additional 20
-    private int maxDepth = 20;  // max depth within one program
-    private int maxNodes = 100;  // max nodes within one program
-
+
+    /**
+     * number of internal replications from which the best result is picked; default from the paper
+     * is 20
+     */
+    private int numberRuns = 20;
+
+    /**
+     * maximal depth of the S-expression tree; default from the paper is 20
+     */
+    private int maxDepth = 20;
+
+    /**
+     * maximal number of nodes of the S-expression tree; default from the paper is 100
+     */
+    private int maxNodes = 100;
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.IParameterizable#setParameter(java.lang.String)
+     */
     @Override
     public void setParameter(String parameters) {
-        
+
         String[] params = parameters.split(",");
         String[] keyvalue = new String[2];
 
-        for(int i=0; i < params.length; i++) {
+        for (int i = 0; i < params.length; i++) {
             keyvalue = params[i].split(":");
-            
-            switch(keyvalue[0]) {
+
+            switch (keyvalue[0])
+            {
                 case "populationSize":
                     this.populationSize = Integer.parseInt(keyvalue[1]);
-                break;
-                
+                    break;
+
                 case "initMinDepth":
                     this.initMinDepth = Integer.parseInt(keyvalue[1]);
-                break;
-                
+                    break;
+
                 case "tournamentSize":
                     this.tournamentSize = Integer.parseInt(keyvalue[1]);
-                break;
-                
+                    break;
+
                 case "maxGenerations":
                     this.maxGenerations = Integer.parseInt(keyvalue[1]);
-                break;
-                
+                    break;
+
                 case "errorType2Weight":
                     this.errorType2Weight = Double.parseDouble(keyvalue[1]);
-                break;
-                
+                    break;
+
                 case "numberRuns":
                     this.numberRuns = Integer.parseInt(keyvalue[1]);
-                break;
-                
+                    break;
+
                 case "maxDepth":
                     this.maxDepth = Integer.parseInt(keyvalue[1]);
-                break;
-                
+                    break;
+
                 case "maxNodes":
                     this.maxNodes = Integer.parseInt(keyvalue[1]);
-                break;
-            }
-        }
-        
+                    break;
+            }
+        }
+
         this.classifier = new GPVVClassifier();
-        ((GPVClassifier)this.classifier).configure(populationSize, initMinDepth, initMaxDepth, tournamentSize, maxGenerations, errorType2Weight, numberRuns, maxDepth, maxNodes);
+        ((GPVClassifier) this.classifier)
+            .configure(populationSize, initMinDepth, initMaxDepth, tournamentSize, maxGenerations,
+                       errorType2Weight, numberRuns, maxDepth, maxNodes);
     }
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see
+     * de.ugoe.cs.cpdp.training.ISetWiseTrainingStrategy#apply(org.apache.commons.collections4.list.
+     * SetUniqueList)
+     */
     @Override
     public void apply(SetUniqueList<Instances> traindataSet) {
         try {
             classifier.buildClassifier(traindataSet);
-        }catch(Exception e) {
+        }
+        catch (Exception e) {
             throw new RuntimeException(e);
         }
     }
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.training.ISetWiseTrainingStrategy#getName()
+     */
     @Override
     public String getName() {
@@ -130,19 +195,47 @@
     }
 
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.cpdp.training.IWekaCompatibleTrainer#getClassifier()
+     */
     @Override
     public Classifier getClassifier() {
         return this.classifier;
     }
-    
+
+    /**
+     * <p>
+     * Internal helper class that stores the data in a format that can be used by the genetic
+     * program.
+     * </p>
+     * 
+     * @author Alexander Trautsch
+     */
     public class InstanceData {
+
+        /**
+         * instances values
+         */
         private double[][] instances_x;
+
+        /**
+         * class labels
+         */
         private boolean[] instances_y;
-        
+
+        /**
+         * <p>
+         * Constructor. Creates the internal data representation.
+         * </p>
+         *
+         * @param instances
+         */
         public InstanceData(Instances instances) {
-            this.instances_x = new double[instances.numInstances()][instances.numAttributes()-1];
+            this.instances_x = new double[instances.numInstances()][instances.numAttributes() - 1];
             this.instances_y = new boolean[instances.numInstances()];
-            
+
             Instance current;
-            for(int i=0; i < this.instances_x.length; i++) {
+            for (int i = 0; i < this.instances_x.length; i++) {
                 current = instances.get(i);
                 this.instances_x[i] = WekaUtils.instanceValues(current);
@@ -150,32 +243,119 @@
             }
         }
-        
+
+        /**
+         * <p>
+         * returns the instance values
+         * </p>
+         *
+         * @return
+         */
         public double[][] getX() {
             return instances_x;
         }
+
+        /**
+         * <p>
+         * returns the instance labels
+         * </p>
+         *
+         * @return
+         */
         public boolean[] getY() {
             return instances_y;
         }
     }
-    
+
     /**
      * One Run executed by a GP Classifier
      */
     public class GPRun extends AbstractClassifier {
+
+        /**
+         * generated serialization ID
+         */
         private static final long serialVersionUID = -4250422550107888789L;
 
+        /**
+         * size of the population of the genetic program
+         */
         private int populationSize;
+
+        /**
+         * minimal depth of the S-expression tree at the start of the training
+         */
         private int initMinDepth;
+
+        /**
+         * maximal depth of the S-expression tree at the start of the training
+         */
         private int initMaxDepth;
+
+        /**
+         * size of the tournaments used for selection
+         */
         private int tournamentSize;
+
+        /**
+         * number of genetic generations considered (i.e., number of iterations
+         */
         private int maxGenerations;
+
+        /**
+         * weight factor for the prediction errors for cost estimation
+         */
         private double errorType2Weight;
+
+        /**
+         * maximal depth of the S-expression tree
+         */
         private int maxDepth;
+
+        /**
+         * maximal number of nodes of the S-expression tree
+         */
         private int maxNodes;
-        
+
+        /**
+         * genetic program
+         */
         private GPGenotype gp;
+
+        /**
+         * description of the problem to be solved by the genetic program
+         */
         private GPProblem problem;
-        
-        public void configure(int populationSize, int initMinDepth, int initMaxDepth, int tournamentSize, int maxGenerations, double errorType2Weight, int maxDepth, int maxNodes) {
+
+        /**
+         * <p>
+         * Configures the runner
+         * </p>
+         *
+         * @param populationSize
+         *            the population size
+         * @param initMinDepth
+         *            the initial minimal depth of the S-expression tree
+         * @param initMaxDepth
+         *            the initial maximal depth of the S-expression tree
+         * @param tournamentSize
+         *            the tournament size for selection
+         * @param maxGenerations
+         *            the number of generations created
+         * @param errorType2Weight
+         *            weigth factor for the prediction errors
+         * @param maxDepth
+         *            maximal depth of the S-expression tree
+         * @param maxNodes
+         *            maximal number of nodes of the S-expression tree
+         */
+        public void configure(int populationSize,
+                              int initMinDepth,
+                              int initMaxDepth,
+                              int tournamentSize,
+                              int maxGenerations,
+                              double errorType2Weight,
+                              int maxDepth,
+                              int maxNodes)
+        {
             this.populationSize = populationSize;
             this.initMinDepth = initMinDepth;
@@ -187,36 +367,117 @@
             this.maxNodes = maxNodes;
         }
-        
+
+        /**
+         * <p>
+         * returns the genetic program
+         * </p>
+         *
+         * @return the genetic program
+         */
         public GPGenotype getGp() {
             return this.gp;
         }
-        
+
+        /**
+         * <p>
+         * returns the variables of the genetic program
+         * </p>
+         *
+         * @return the variables
+         */
         public Variable[] getVariables() {
-            return ((CrossPareGP)this.problem).getVariables();
-        }
-
+            return ((CrossPareGP) this.problem).getVariables();
+        }
+
+        /*
+         * (non-Javadoc)
+         * 
+         * @see weka.classifiers.Classifier#buildClassifier(weka.core.Instances)
+         */
         @Override
         public void buildClassifier(Instances traindata) throws Exception {
-            InstanceData train = new InstanceData(traindata);            
-            this.problem = new CrossPareGP(train.getX(), train.getY(), this.populationSize, this.initMinDepth, this.initMaxDepth, this.tournamentSize, this.errorType2Weight, this.maxDepth, this.maxNodes);
+            InstanceData train = new InstanceData(traindata);
+            this.problem =
+                new CrossPareGP(train.getX(), train.getY(), this.populationSize, this.initMinDepth,
+                                this.initMaxDepth, this.tournamentSize, this.errorType2Weight,
+                                this.maxDepth, this.maxNodes);
             this.gp = problem.create();
             this.gp.evolve(this.maxGenerations);
         }
-        
+
         /**
          * GPProblem implementation
+         * 
+         * @author Alexander Trautsch
          */
         class CrossPareGP extends GPProblem {
+
+            /**
+             * Instance values of the training data
+             */
             private double[][] instances;
+
+            /**
+             * Classifications of the training data
+             */
             private boolean[] output;
 
+            /**
+             * maximal depth of the S-expression tree
+             */
             private int maxDepth;
+
+            /**
+             * maximal number of nodes of the S-expression tree
+             */
             private int maxNodes;
-            
+
+            /**
+             * variables of the genetic program
+             */
             private Variable[] x;
 
-            public CrossPareGP(double[][] instances, boolean[] output, int populationSize, int minInitDept, int maxInitDepth, int tournamentSize, double errorType2Weight, int maxDepth, int maxNodes) throws InvalidConfigurationException {
+            /**
+             * 
+             * <p>
+             * Constructor. Creates a new genetic program.
+             * </p>
+             *
+             * @param instances
+             *            instance values of the training data
+             * @param output
+             *            classifications of the training data
+             * @param populationSize
+             *            the population size
+             * @param initMinDepth
+             *            the initial minimal depth of the S-expression tree
+             * @param initMaxDepth
+             *            the initial maximal depth of the S-expression tree
+             * @param tournamentSize
+             *            the tournament size for selection
+             * @param maxGenerations
+             *            the number of generations created
+             * @param errorType2Weight
+             *            weigth factor for the prediction errors
+             * @param maxDepth
+             *            maximal depth of the S-expression tree
+             * @param maxNodes
+             *            maximal number of nodes of the S-expression tree
+             * @throws InvalidConfigurationException
+             *             thrown in case the problem cannot be created
+             */
+            public CrossPareGP(double[][] instances,
+                               boolean[] output,
+                               int populationSize,
+                               int minInitDept,
+                               int maxInitDepth,
+                               int tournamentSize,
+                               double errorType2Weight,
+                               int maxDepth,
+                               int maxNodes)
+                throws InvalidConfigurationException
+            {
                 super(new GPConfiguration());
-                
+
                 this.instances = instances;
                 this.output = output;
@@ -226,20 +487,22 @@
                 Configuration.reset();
                 GPConfiguration config = this.getGPConfiguration();
-                
+
                 this.x = new Variable[this.instances[0].length];
-               
-                for(int j=0; j < this.x.length; j++) {
-                    this.x[j] = Variable.create(config, "X"+j, CommandGene.DoubleClass);    
-                }
-
-                config.setGPFitnessEvaluator(new DeltaGPFitnessEvaluator()); // smaller fitness is better
-                //config.setGPFitnessEvaluator(new DefaultGPFitnessEvaluator()); // bigger fitness is better
+
+                for (int j = 0; j < this.x.length; j++) {
+                    this.x[j] = Variable.create(config, "X" + j, CommandGene.DoubleClass);
+                }
+
+                config.setGPFitnessEvaluator(new DeltaGPFitnessEvaluator()); // smaller fitness is
+                                                                             // better
+                // config.setGPFitnessEvaluator(new DefaultGPFitnessEvaluator()); // bigger fitness
+                // is better
 
                 config.setMinInitDepth(minInitDept);
                 config.setMaxInitDepth(maxInitDepth);
-                
-                config.setCrossoverProb((float)0.60);
-                config.setReproductionProb((float)0.10);
-                config.setMutationProb((float)0.30);
+
+                config.setCrossoverProb((float) 0.60);
+                config.setReproductionProb((float) 0.10);
+                config.setMutationProb((float) 0.30);
 
                 config.setSelectionMethod(new TournamentSelector(tournamentSize));
@@ -248,51 +511,74 @@
 
                 config.setMaxCrossoverDepth(4);
-                config.setFitnessFunction(new CrossPareFitness(this.x, this.instances, this.output, errorType2Weight));
+                config.setFitnessFunction(new CrossPareFitness(this.x, this.instances, this.output,
+                                                               errorType2Weight));
                 config.setStrictProgramCreation(true);
             }
 
-            // used for running the fitness function again for testing
+            /**
+             * <p>
+             * Returns the variables of the problem. Used for running the fitness function again for
+             * testing.
+             * </p>
+             *
+             * @return the variables
+             */
             public Variable[] getVariables() {
                 return this.x;
             }
 
-
+            /**
+             * creates the genetic program
+             */
+            @SuppressWarnings("rawtypes")
             public GPGenotype create() throws InvalidConfigurationException {
                 GPConfiguration config = this.getGPConfiguration();
 
                 // return type
-                Class[] types = {CommandGene.DoubleClass};
+                Class[] types =
+                    { CommandGene.DoubleClass };
 
                 // Arguments of result-producing chromosome: none
-                Class[][] argTypes = { {} };
+                Class[][] argTypes =
+                    { { } };
 
                 // variables + functions, we set the variables with the values of the instances here
                 CommandGene[] vars = new CommandGene[this.instances[0].length];
-                for(int j=0; j < this.instances[0].length; j++) {
+                for (int j = 0; j < this.instances[0].length; j++) {
                     vars[j] = this.x[j];
                 }
-                CommandGene[] funcs = {
-                    new Add(config, CommandGene.DoubleClass),
-                    new Subtract(config, CommandGene.DoubleClass),
-                    new Multiply(config, CommandGene.DoubleClass),
-                    new Divide(config, CommandGene.DoubleClass),
-                    new Sine(config, CommandGene.DoubleClass),
-                    new Cosine(config, CommandGene.DoubleClass),
-                    new Exp(config, CommandGene.DoubleClass),
-                    new Log(config, CommandGene.DoubleClass),
-                    new GT(config, CommandGene.DoubleClass),
-                    new Max(config, CommandGene.DoubleClass),
-                    new Terminal(config, CommandGene.DoubleClass, -100.0, 100.0, true), // min, max, whole numbers
-                };
-
-                CommandGene[] comb = (CommandGene[])ArrayUtils.addAll(vars, funcs);
-                CommandGene[][] nodeSets = {
-                    comb,
-                };
-                
+                CommandGene[] funcs =
+                    { new Add(config, CommandGene.DoubleClass),
+                        new Subtract(config, CommandGene.DoubleClass),
+                        new Multiply(config, CommandGene.DoubleClass),
+                        new Divide(config, CommandGene.DoubleClass),
+                        new Sine(config, CommandGene.DoubleClass),
+                        new Cosine(config, CommandGene.DoubleClass),
+                        new Exp(config, CommandGene.DoubleClass),
+                        new Log(config, CommandGene.DoubleClass),
+                        new GT(config, CommandGene.DoubleClass),
+                        new Max(config, CommandGene.DoubleClass),
+                        new Terminal(config, CommandGene.DoubleClass, -100.0, 100.0, true), // min,
+                                                                                            // max,
+                                                                                            // whole
+                                                                                            // numbers
+                    };
+
+                CommandGene[] comb = (CommandGene[]) ArrayUtils.addAll(vars, funcs);
+                CommandGene[][] nodeSets =
+                    { comb, };
+
                 // we only have one chromosome so this suffices
-                int minDepths[] = {config.getMinInitDepth()};
-                int maxDepths[] = {this.maxDepth};
-                GPGenotype result = GPGenotype.randomInitialGenotype(config, types, argTypes, nodeSets, minDepths, maxDepths, this.maxNodes, false); // 40 = maxNodes, true = verbose output
+                int minDepths[] =
+                    { config.getMinInitDepth() };
+                int maxDepths[] =
+                    { this.maxDepth };
+                GPGenotype result =
+                    GPGenotype.randomInitialGenotype(config, types, argTypes, nodeSets, minDepths,
+                                                     maxDepths, this.maxNodes, false); // 40 =
+                                                                                       // maxNodes,
+                                                                                       // true =
+                                                                                       // verbose
+                                                                                       // output
 
                 return result;
@@ -300,27 +586,73 @@
         }
 
-        
-        /**
-         * Fitness function
+        /**
+         * Internal helper class for the fitness function.
+         * 
+         * @author Alexander Trautsch
          */
         class CrossPareFitness extends GPFitnessFunction {
-            
+
+            /**
+             * generated serialization ID
+             */
             private static final long serialVersionUID = 75234832484387L;
 
+            /**
+             * variables of the genetic program
+             */
             private Variable[] x;
 
+            /**
+             * instance values of the training data
+             */
             private double[][] instances;
+
+            /**
+             * classifications of the training data
+             */
             private boolean[] output;
 
+            /**
+             * weight of the error costs
+             */
             private double errorType2Weight = 1.0;
 
             // needed in evaluate
-            //private Object[] NO_ARGS = new Object[0];
-
+            // private Object[] NO_ARGS = new Object[0];
+
+            /**
+             * fitness value
+             */
             private double sfitness = 0.0f;
+
+            /**
+             * type I error
+             */
             private int errorType1 = 0;
+
+            /**
+             * type II error
+             */
             private int errorType2 = 0;
 
-            public CrossPareFitness(Variable[] x, double[][] instances, boolean[] output, double errorType2Weight) {
+            /**
+             * <p>
+             * Constructor. Creates a new fitness function.
+             * </p>
+             *
+             * @param x
+             *            variables of the genetic program
+             * @param instances
+             *            instance values of the training data
+             * @param output
+             *            classification of the training data
+             * @param errorType2Weight
+             *            weight of the error costs
+             */
+            public CrossPareFitness(Variable[] x,
+                                    double[][] instances,
+                                    boolean[] output,
+                                    double errorType2Weight)
+            {
                 this.x = x;
                 this.instances = instances;
@@ -329,16 +661,44 @@
             }
 
+            /**
+             * <p>
+             * returns the type I error
+             * </p>
+             *
+             * @return type I error
+             */
             public int getErrorType1() {
                 return this.errorType1;
             }
 
+            /**
+             * <p>
+             * returns the type II error
+             * </p>
+             *
+             * @return type II error
+             */
             public int getErrorType2() {
                 return this.errorType2;
             }
 
+            /**
+             * <p>
+             * returns the value of the secondary fitness function
+             * </p>
+             *
+             * @return secondary fitness
+             */
             public double getSecondFitness() {
                 return this.sfitness;
             }
 
+            /**
+             * <p>
+             * returns the number of training instances
+             * </p>
+             *
+             * @return number of instances
+             */
             public int getNumInstances() {
                 return this.instances.length;
@@ -346,7 +706,13 @@
 
             /**
-             * This is the fitness function
+             * <p>
+             * The fitness function. Our fitness is best if we have the less wrong classifications,
+             * this includes a weight for type2 errors.
+             * </p>
              * 
-             * Our fitness is best if we have the less wrong classifications, this includes a weight for type2 errors
+             * @param program
+             *            the genetic program whose fitness is evaluated.
+             * 
+             * @see org.jgap.gp.GPFitnessFunction#evaluate(org.jgap.gp.IGPProgram)
              */
             @Override
@@ -360,8 +726,9 @@
                 this.errorType2 = 0;
 
-                for(int i=0; i < this.instances.length; i++) {
-
-                    // requires that we have a variable for each column of our dataset (attribute of instance)
-                    for(int j=0; j < this.x.length; j++) {
+                for (int i = 0; i < this.instances.length; i++) {
+
+                    // requires that we have a variable for each column of our dataset (attribute of
+                    // instance)
+                    for (int j = 0; j < this.x.length; j++) {
                         this.x[j].set(this.instances[i][j]);
                     }
@@ -370,10 +737,11 @@
                     value = program.execute_double(0, this.x);
 
-                    if(value < 0.5) {
-                        if(this.output[i] != true) {
+                    if (value < 0.5) {
+                        if (this.output[i] != true) {
                             this.errorType1 += 1;
                         }
-                    }else {
-                        if(this.output[i] == true) {
+                    }
+                    else {
+                        if (this.output[i] == true) {
                             this.errorType2 += 1;
                         }
@@ -382,9 +750,10 @@
 
                 // now calc pfitness
-                pfitness = (this.errorType1 + this.errorType2Weight * this.errorType2) / this.instances.length;
+                pfitness = (this.errorType1 + this.errorType2Weight * this.errorType2) /
+                    this.instances.length;
 
                 // number of nodes in the programm, if lower then 10 we assign sFitness of 10
                 // we can set metadata with setProgramData to save this
-                if(program.getChromosome(0).getSize(0) < 10) {
+                if (program.getChromosome(0).getSize(0) < 10) {
                     program.setApplicationData(10.0f);
                 }
